# AI Opinion Miner Cloud - API

## Test Coverage Report

```text
Name                            Stmts   Miss  Cover
---------------------------------------------------
opinion_miner_api/__init__.py       0      0   100%
opinion_miner_api/main.py          23      0   100%
opinion_miner_api/model.py         73      9    88%
tests/test_api.py                  48      0   100%
tests/test_main.py                 11      0   100%
tests/test_model.py                 8      0   100%
---------------------------------------------------
TOTAL                             163      9    94%
```

## Installation

1. **Clone the repository**:

    ```bash
    git clone https://github.com/yourusername/opinion-miner-api.git
    cd opinion-miner-api
    ```

2. **Create and activate a virtual environment**:

    ```bash
    python -m venv venv-opinion-miner-api
    source venv-opinion-miner-api/bin/activate  # On Windows use `venv-opinion-miner-api\Scripts\activate`
    ```

3. **Install the dependencies**:

    ```bash
    pip install -r requirements.txt  # NOTE: torch CPU installation
    ```

4. **Run the application**:

    ```bash
    uvicorn opinion_miner_api.main:app --host 0.0.0.0 --port 8000
    ```

5. **Run the tests** (optional):

    ```bash
    pytest --cov=opinion_miner_api tests/
    ```

6. **Build the Docker image** (optional):

    ```bash
    docker build -t opinion-miner-api .
    ```

7. **Run the Docker container** (optional):

    ```bash
    docker run -p 8000:8000 opinion-miner-api
    ```

8. **Test the API** (optional):

    ```bash
    curl -X POST "http://localhost:8000/predict" -H "Content-Type: application/json" -d '{"text":"I love Docker!"}'
    ```
