#!/usr/bin/env python3

"""Test opinion_miner_api/main.py"""

from fastapi.testclient import TestClient
from opinion_miner_api.main import app

client = TestClient(app)


def test_root():
    response = client.get("/")
    assert response.status_code == 200
    assert response.json() == {"message": "Welcome to the AI Opinion Miner Cloud API."}


def test_404():
    response = client.get("/nonexistent")
    assert response.status_code == 404
    assert "detail" in response.json()
